### Have cran package "deSolve" installed


### Source model script. In this case, it is V&G Model 1.R

source("V&G Model 1.R")



### The below function contains a loop that spawns as many datasets as the
	### variable "number" is set at. It takes the arguments xInit (initial
	### species values), t (timepoints), params (parameter values), noise (
	### the standard deviation of the Gaussian noise to add to the data,
	### in order to perturb the data. The save location should be
	### changed depending on where the file should be saved to and which
	### computer operating system is being used (Windows requires the use of
	### .R at the end of the file name, in order to allow the file to save
	### in the correct format)

createDatasets <- function(xInit,t,params,noise,number,averageSNR)
{
	
		ode.data <- simulateVGModel1(xInit,t,params)

		data.true <- ode.data[,2:dim(ode.data)[2]]
	
		data.full <- data.true
		data <- data.true
	      data[data < 0] <- 0.0001
		# Cannot have negative species concentrations. All values less
			# than zero are changed to 0.0001

	for(species in 1:dim(data.true)[2])
	{
      	data[,species] <- (data[,species])+rnorm(dim(data.true
					)[1],0,noise)
	}



	dataset <- list(data=data,data.true=data.true,time=t,
				params=params,sdNoise=noise)

	save(dataset,file=paste("V&G Model 1 SD Noise ",noise,
			" Average SNR ",averageSNR," ",i,".R", sep=""))}

	
}


### Specifications of the initial species values, timepoints, parameter
	### values, number of datasets and noise. Can change as desired, below
	### are the default values

speciesNames <- c("S","DS","R","RS","Rpp")
	# Note: If data is not simulated via the script "V&G Model 1", then the
		# order of species might change and thus the names will not be
		# correctly assigned. DS is degraded protein S and does not stand
		# for the gradient (or differential) of protein S

speciesInitial <- c(1,0,1,0,0)


names(speciesInitial) <- speciesNames

t <- c(0,1,2,4,5,7,10,15,20,30,40,50,60,80,100)


paramNames <- c(paste("k",1:4,sep=""),"V","Km")



params <- c(0.07,0.6,0.05,0.3,0.017,0.3)


names(params) <- paramNames

number <- 10



noise <- 0.064 
averageSNR <- 10



#noise <- 0.09
#averageSNR <- 5



### Creating the datasets for the V&G model 1

createDatasets(speciesInitial,t,params,noise,number,averageSNR)









